import { ChakraProvider } from "@chakra-ui/react";
import { Outlet, createBrowserRouter } from "react-router-dom";
import { LoginPage } from "./pages/login/LoginPage";
import { YunaTheme } from "./theme";
import { HomePage } from "./pages/home/HomePage";



export const router = createBrowserRouter([
    {
        path: "/",
        element: <><ChakraProvider theme={YunaTheme}><Outlet /></ChakraProvider></>,
        errorElement: <h1>Something gone wrong</h1>,
        children:
            [
                {
                    path: "home",
                    element: <HomePage />
                },
                {
                    path: "settings",
                    element: <>set</>
                },
                {
                    path: "login",
                    element: <LoginPage />
                }

            ]
    }
]);